<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelRatePlanRestriction ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelRatePlanRestriction extends AbstractStructArrayBase
{
    /**
     * The Restriction
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelRatePlanRestriction[]
     */
    public $Restriction;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelRatePlanRestriction
     * @uses ArrayOfJPSOAP_HotelRatePlanRestriction::setRestriction()
     * @param \StructType\JPSOAP_HotelRatePlanRestriction[] $restriction
     */
    public function __construct(array $restriction = array())
    {
        $this
            ->setRestriction($restriction);
    }
    /**
     * Get Restriction value
     * @return \StructType\JPSOAP_HotelRatePlanRestriction[]|null
     */
    public function getRestriction()
    {
        return $this->Restriction;
    }
    /**
     * Set Restriction value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanRestriction[] $restriction
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanRestriction
     */
    public function setRestriction(array $restriction = array())
    {
        foreach ($restriction as $arrayOfJPSOAP_HotelRatePlanRestrictionRestrictionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelRatePlanRestrictionRestrictionItem instanceof \StructType\JPSOAP_HotelRatePlanRestriction) {
                throw new \InvalidArgumentException(sprintf('The Restriction property can only contain items of \StructType\JPSOAP_HotelRatePlanRestriction, "%s" given', is_object($arrayOfJPSOAP_HotelRatePlanRestrictionRestrictionItem) ? get_class($arrayOfJPSOAP_HotelRatePlanRestrictionRestrictionItem) : gettype($arrayOfJPSOAP_HotelRatePlanRestrictionRestrictionItem)), __LINE__);
            }
        }
        $this->Restriction = $restriction;
        return $this;
    }
    /**
     * Add item to Restriction value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanRestriction $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanRestriction
     */
    public function addToRestriction(\StructType\JPSOAP_HotelRatePlanRestriction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelRatePlanRestriction) {
            throw new \InvalidArgumentException(sprintf('The Restriction property can only contain items of \StructType\JPSOAP_HotelRatePlanRestriction, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Restriction[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelRatePlanRestriction|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelRatePlanRestriction|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelRatePlanRestriction|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelRatePlanRestriction|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelRatePlanRestriction|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Restriction
     */
    public function getAttributeName()
    {
        return 'Restriction';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanRestriction
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
